#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct Leader *Lref; // :    .
typedef struct Trailer *Tref; // :    .

//   .
typedef struct Leader 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct Trailer
{
  Lref Id;
  Tref Next;
};

//   .
typedef Lref TipElement; //    .
typedef struct Zveno *svqz;
typedef struct Zveno
{
  TipElement Element; //   .
  svqz Sled;
};

class Spisok
{
  private:
	 Lref Head; //     .
	 Lref Tail; //   
					//     .
	 void Udalenie_A (svqz *, svqz *, TipElement *);
	 void Dobavlenie (svqz *, svqz *, TipElement);
	 void SearchGraph (int, Lref *);
  public:
	 Spisok() {//   .
				  Head = Tail =  new (Leader); }
	 Lref GetHead() { return Head; }
	 Lref GetTail() { return Tail; }
	 void MakeGraph ();
	 void PrintGraph ();
	 void Breadth_First_Search (Lref);
};

void main ()
{
  Spisok A;
  Lref t; //   
			 //    .

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //    .
  cout<<"  ...\n";
  t = A.GetHead();
  while (t!=A.GetTail())
	 { (*t).Flag = TRUE; t = (*t).Next; }
  A.Breadth_First_Search (A.GetHead()); cout<<endl;
}

void Spisok::SearchGraph (int w, Lref *h)
//     
//  w  ,      Head.
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0;
	 (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head  
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
	  cout<<"   : "; cin>>y;
	  //,      (x,y)?
	  SearchGraph (x, &p); SearchGraph (y,&q);
	  r = (*p).Trail; Res = FALSE;
	  while ((r!=NULL)&&(!Res))
		 if ((*r).Id==q) Res = TRUE;
		 else r = (*r).Next;
	  if (!Res) //  ,     .
		{ t = new (Trailer); (*t).Id = q;
		  (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; }
	  cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,  
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
	  cout<<(*p).Key<<"("; q = (*p).Trail;
	  while (q!=NULL)
		{ cout<<(*(*q).Id).Key; q = (*q).Next; }
	  cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Dobavlenie (svqz *L, svqz *R, TipElement elem)
//  elem  ,   L  R.
{
  svqz K = new (Zveno);

  K->Element = elem; K->Sled = NULL;
  if (*L==NULL)
	 { (*L) = K; (*R) = K; }
  else { (*R)->Sled = K; (*R) = K; }
}

void Spisok::Udalenie_A (svqz *L, svqz *R, TipElement *A)
//   ,   L  R 
//     A.
{
  svqz q;

  if ((*L)!=NULL)
	if ((*L)->Sled!=NULL)
	  {
		  (*A) = (*L)->Element; q = (*L);
		  (*L) = (*L)->Sled; delete q;
	  }
	else {
			 (*A) = (*L)->Element; delete *L;
			 (*L) = (*R) = NULL;
		  }
}

void Spisok::Breadth_First_Search (Lref H)
//   ,   ,   H
//( ).
{
  svqz L; //   .
  svqz R; //    .
  Lref p; // .
  Tref t; // .

  L = R = NULL; //  .
  Dobavlenie (&L,&R,H); H->Flag = FALSE;
  while ( L!=NULL )
	//   ...
	{
	  Udalenie_A (&L,&R,&p);
	  cout << p->Key << " "; // .
	  t = p->Trail;
	  while ( t!=NULL )
	  {
		 if ( t->Id->Flag )
		  {
			 Dobavlenie (&L,&R,t->Id);
			 t->Id->Flag = FALSE;
		  }
		 t = t->Next;
	  }
	}
}